diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 49e431012..ae66fc3c1 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -165,6 +165,18 @@ public class PacketHandlerClient extends PacketHandler
         mc.thePlayer.id = loginPacket.playerEntityIdAndProtocolVersion;
         NetworkManager.PACKET_DELAY = loginPacket.packetDelay;
         Registries.RECIPES = new RecipeRegistry();
+
+        addToSendQueue(new PacketPlayerConfig(mc.thePlayer.playerConfig));
+    }
+
+    @Override
+    public void handlePlayerConfig(PacketPlayerConfig packetPlayerConfig) {
+        if (packetPlayerConfig.entityId >= 0 && packetPlayerConfig.entityId != mc.thePlayer.id) {
+            Entity e = getEntityByID(packetPlayerConfig.entityId);
+            if (e instanceof Player) {
+                ((Player) e).playerConfig.config = packetPlayerConfig.config;
+            }
+        }
     }
 
     @Override
@@ -299,6 +311,7 @@ public class PacketHandlerClient extends PacketHandler
         float f = (float) (addPlayerPacket.rotation * 360) / 256F;
         float f1 = (float) (addPlayerPacket.pitch * 360) / 256F;
         PlayerRemote playerRemote = new PlayerRemote(mc.currentWorld, addPlayerPacket.name, addPlayerPacket.uuid);
+        playerRemote.playerConfig.config = addPlayerPacket.playerConfig;
         playerRemote.xo = playerRemote.serverPosX = addPlayerPacket.xPosition;
         playerRemote.yo = playerRemote.serverPosY = addPlayerPacket.yPosition;
         playerRemote.zo = playerRemote.serverPosZ = addPlayerPacket.zPosition;
@@ -366,7 +379,7 @@ public class PacketHandlerClient extends PacketHandler
     {
         if (mc.currentWorld.isBlockLoaded(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition))
         {
-            TileEntity tileentity = mc.currentWorld.getBlockEntity(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition);
+            TileEntity tileentity = mc.currentWorld.getTileEntity(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition);
             if (tileentity instanceof TileEntityMobSpawner)
             {
                 TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) tileentity;
@@ -746,7 +759,7 @@ public class PacketHandlerClient extends PacketHandler
             passenger = mc.thePlayer;
         }
         if (setRidingPacket.isTileEntity) {
-            vehicle = (IVehicle) worldClientMP.getBlockEntity(setRidingPacket.x, setRidingPacket.y, setRidingPacket.z);
+            vehicle = (IVehicle) worldClientMP.getTileEntity(setRidingPacket.x, setRidingPacket.y, setRidingPacket.z);
         } else {
             vehicle = getEntityByID(setRidingPacket.vehicleId);
         }
@@ -900,7 +913,7 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handleOpenFlagWindow(PacketFlagOpen flagOpenPacket)
     {
-        TileEntity tileEntity = worldClientMP.getBlockEntity(flagOpenPacket.x, flagOpenPacket.y, flagOpenPacket.z);
+        TileEntity tileEntity = worldClientMP.getTileEntity(flagOpenPacket.x, flagOpenPacket.y, flagOpenPacket.z);
         if (tileEntity instanceof TileEntityFlag)
         {
             TileEntityFlag tileEntityFlag = (TileEntityFlag) tileEntity;
@@ -1121,24 +1134,24 @@ public class PacketHandlerClient extends PacketHandler
     }
 
     @Override
-    public void handleTileEntityData(PacketBlockEntityData blockEntityDataPacket)
+    public void handleTileEntityData(PacketTileEntityData packetTileEntityData)
     {
-        Class<?> clazz = TileEntityDispatcher.getClassFromID(blockEntityDataPacket.tag.getString("id"));
+        Class<?> clazz = TileEntityDispatcher.getClassFromID(packetTileEntityData.tag.getString("id"));
         if (clazz == null) return;
-        TileEntity existingTileEntity = worldClientMP.getBlockEntity(blockEntityDataPacket.tag.getInteger("x"), blockEntityDataPacket.tag.getInteger("y"), blockEntityDataPacket.tag.getInteger("z"));
+        TileEntity existingTileEntity = worldClientMP.getTileEntity(packetTileEntityData.tag.getInteger("x"), packetTileEntityData.tag.getInteger("y"), packetTileEntityData.tag.getInteger("z"));
         if (existingTileEntity == null || existingTileEntity.getClass() != clazz)
         {
-            TileEntity tileEntity = TileEntityDispatcher.createAndLoadEntity(blockEntityDataPacket.tag);
+            TileEntity tileEntity = TileEntityDispatcher.createAndLoadEntity(packetTileEntityData.tag);
             if (tileEntity != null)
             {
-                mc.currentWorld.setBlockTileEntity(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity);
+                mc.currentWorld.setTileEntity(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity);
             }
         }
         else
         {
-            existingTileEntity.readFromNBT(blockEntityDataPacket.tag);
+            existingTileEntity.readFromNBT(packetTileEntityData.tag);
         }
-        worldClientMP.markBlockDirty(blockEntityDataPacket.tag.getInteger("x"), blockEntityDataPacket.tag.getInteger("y"), blockEntityDataPacket.tag.getInteger("z"));
+        worldClientMP.markBlockDirty(packetTileEntityData.tag.getInteger("x"), packetTileEntityData.tag.getInteger("y"), packetTileEntityData.tag.getInteger("z"));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index baf5382db..bf45585fa 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -28,6 +28,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.ITranslatable;
+
 import org.slf4j.Logger;
 
 public class GameSettings {
@@ -171,6 +172,9 @@ public class GameSettings {
 	public OptionBoolean subtitles = new OptionBoolean(this, "subtitles", false);
 	public OptionBoolean developerMode = new OptionBoolean(this, "developerMode", false);
 	public OptionBoolean enableHolidayTextures = new OptionBoolean(this, "enableHolidayTextures", true);
+	public OptionBoolean dynamicCursor = new OptionBoolean(this, "dynamicCursor", true);
+
+	public OptionBoolean playerLeftHanded = new OptionBoolean(this, "playerLeftHanded", false);
 
 	public KeyBinding keyAttack = new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0);
 	public KeyBinding keyInteract = new KeyBinding("key.interact").setDefault(InputDevice.mouse, 1);
@@ -423,6 +427,9 @@ public class GameSettings {
 				mc.currentWorld.setDifficulty(difficulty.value, false);
 			}
 		}
+		if(option == playerLeftHanded && mc.thePlayer != null) {
+			mc.thePlayer.playerConfig.setLeftHand(playerLeftHanded.value);
+		}
 		if(option == enableVsync) mc.gameWindow.setVsync(enableVsync.value);
 		if(option == fancyGraphics) mc.renderGlobal.loadRenderers();
 		if(option == ambientOcclusion) mc.renderGlobal.loadRenderers();
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 3441840c7..702faaedf 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -259,7 +259,7 @@ public abstract class PlayerController {
 		int blockId = world.getBlockId(blockX, blockY, blockZ);
 		if (player.getHeldObject() == null) {
 			if (player.isSneaking() && itemstack == null) { // If crouched and hand empty try to pickup block entity
-				TileEntity tileEntity = world.getBlockEntity(blockX, blockY, blockZ);
+				TileEntity tileEntity = world.getTileEntity(blockX, blockY, blockZ);
 				if (tileEntity != null && tileEntity.canBeCarried(world, player)) {
 					player.setHeldObject(tileEntity.pickup(world, player));
 					return true;
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
index ea84e2740..302e025ad 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
@@ -18,7 +18,7 @@ public class PlayerControllerSP extends PlayerController {
 		if (!player.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return false;
 		int id = mc.currentWorld.getBlockId(x, y, z);
 		int meta = mc.currentWorld.getBlockMetadata(x, y, z);
-		TileEntity tileEntity = mc.currentWorld.getBlockEntity(x, y, z);
+		TileEntity tileEntity = mc.currentWorld.getTileEntity(x, y, z);
 		boolean removed = super.destroyBlock(x, y, z, side, player);
 		ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index b033462b0..e2298fdac 100644
--- a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -4,13 +4,7 @@ import java.util.HashMap;
 import java.util.Map;
 
 import net.minecraft.client.render.entity.*;
-import net.minecraft.client.render.model.ModelBiped;
-import net.minecraft.client.render.model.ModelChicken;
-import net.minecraft.client.render.model.ModelCow;
-import net.minecraft.client.render.model.ModelSheep;
-import net.minecraft.client.render.model.ModelSkeleton;
-import net.minecraft.client.render.model.ModelSquid;
-import net.minecraft.client.render.model.ModelZombie;
+import net.minecraft.client.render.model.*;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.EntityLightning;
 import net.minecraft.core.entity.EntityPainting;
@@ -20,26 +14,16 @@ import net.minecraft.core.entity.animal.MobChicken;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.entity.animal.MobSquid;
-import net.minecraft.core.entity.monster.MobCreeper;
-import net.minecraft.core.entity.monster.MobSkeleton;
-import net.minecraft.core.entity.monster.MobSlime;
-import net.minecraft.core.entity.monster.MobZombie;
-import net.minecraft.core.entity.monster.MobZombieArmored;
+import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.entity.projectile.ProjectileCannonball;
 import net.minecraft.core.entity.projectile.ProjectileEgg;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.projectile.ProjectileSnowball;
 import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.MobGhastVehicle;
 import net.minecraft.core.item.Items;
 import org.lwjgl.opengl.GL11;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.model.ModelPig;
-import net.minecraft.client.render.model.ModelSheepOverlay;
-import net.minecraft.client.render.model.ModelSheepWool;
-import net.minecraft.client.render.model.ModelSlime;
-import net.minecraft.client.render.model.ModelWolf;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.Entity;
@@ -49,16 +33,10 @@ import net.minecraft.core.entity.EntityPrimedTNT;
 import net.minecraft.core.entity.animal.MobCow;
 import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.animal.MobSheep;
-import net.minecraft.core.entity.monster.MobGhast;
-import net.minecraft.core.entity.monster.MobGiant;
-import net.minecraft.core.entity.monster.MobHuman;
-import net.minecraft.core.entity.monster.MobScorpion;
-import net.minecraft.core.entity.monster.MobSnowman;
-import net.minecraft.core.entity.monster.MobSpider;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.entity.projectile.ProjectilePebble;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.world.World;
 
 public class EntityRenderDispatcher
@@ -76,6 +54,7 @@ public class EntityRenderDispatcher
         renderers.put(MobCreeper.class, new MobRendererCreeper());
         renderers.put(MobSkeleton.class, new MobRendererBipedArmored<>(new ModelSkeleton(), new ModelZombie(1.0f), new ModelZombie(0.5f), 0.5F));
         renderers.put(MobZombie.class, new MobRendererBipedArmored<>(new ModelZombie(), new ModelZombie(1.0f), new ModelZombie(0.5f), 0.5F));
+        renderers.put(MobZombiePig.class, new MobRendererBipedArmored<>(new ModelZombiePigman(), new ModelZombie(1.0f), new ModelZombie(0.5f), 0.5F));
         renderers.put(MobSnowman.class, new MobRendererBiped<>(new ModelZombie(), 0.5F));
         renderers.put(MobZombieArmored.class, new MobRendererZombieArmored(new ModelZombie(), 0.5F));
         renderers.put(MobSlime.class, new MobRendererSlime(new ModelSlime(16), new ModelSlime(0), 0.25F));
@@ -83,7 +62,6 @@ public class EntityRenderDispatcher
         renderers.put(MobHuman.class, new MobRendererHuman());
         renderers.put(MobGiant.class, new MobRendererGiant(new ModelZombie(), 0.5F, 6F));
         renderers.put(MobGhast.class, new MobRendererGhast());
-        renderers.put(MobGhastVehicle.class, new MobRendererGhast());
         renderers.put(MobSquid.class, new MobRendererSquid(new ModelSquid(), 0.7F));
         renderers.put(Mob.class, new MobRenderer<>(new ModelBiped(), 0.5F));
         renderers.put(Entity.class, new EntityRendererDefault());
@@ -95,7 +73,7 @@ public class EntityRenderDispatcher
         renderers.put(EntityItem.class, new EntityRendererItem());
         renderers.put(EntityPrimedTNT.class, new EntityRendererTNT());
         renderers.put(EntityFallingBlock.class, new EntityRendererFallingBlock());
-        renderers.put(MinecartEntity.class, new EntityRendererMinecart());
+        renderers.put(EntityMinecart.class, new EntityRendererMinecart());
         renderers.put(EntityBoat.class, new EntityRendererBoat());
         renderers.put(EntityFishingBobber.class, new EntityRendererFishingBobber());
         renderers.put(MobFireflyCluster.class, new MobRendererFireflyCluster());
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index 2d5be81e9..9888c7fb7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -41,7 +41,7 @@ public class FogManager {
     public void updateBrightness() {
         fogBrightnessOld = fogBrightness;
 
-        float fogModifier = mc.currentWorld.getCurrentWeather() != null ? mc.currentWorld.getCurrentWeather().fogDistance : 1.0f;
+        float fogModifier = mc.currentWorld.getCurrentWeather() != null ? mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
         fogModifier = (1.0f - ((1.0f - fogModifier) * mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower()));
 
         float brightnessAtCamera = mc.currentWorld.getLightBrightness(MathHelper.floor(mc.activeCamera.getX(1f)), MathHelper.floor(mc.activeCamera.getY(1f)), MathHelper.floor(mc.activeCamera.getZ(1f)));
@@ -73,7 +73,7 @@ public class FogManager {
             float maxFogDistance = RenderDistance.EXTREME.chunks * 16;
             float fogDistance = farPlaneDistance;
 
-            float fogModifier = mc.currentWorld.getCurrentWeather() != null ? mc.currentWorld.getCurrentWeather().fogDistance : 1.0f;
+            float fogModifier = mc.currentWorld.getCurrentWeather() != null ? mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
             fogModifier = (1.0f - ((1.0f - fogModifier) * mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower()));
 
             if (fogDistance > maxFogDistance * fogModifier) fogDistance = maxFogDistance * fogModifier;
diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 8044d2c89..3c9e7d855 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -1,10 +1,7 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.entity.player.PlayerLocal;
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.block.ItemBlock;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -21,8 +18,8 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.helper.Side;
 import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.DisplayPos;
 
 import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
 import static org.lwjgl.opengl.GL11.GL_BLEND;
@@ -41,7 +38,6 @@ public class ItemRenderer
         itemToRender = null;
         height = 0.0F;
         oHeight = 0.0F;
-        renderBlocksInstance = new RenderBlocks();
         lastSlot = -1;
         mc = minecraft;
     }
@@ -49,14 +45,6 @@ public class ItemRenderer
         return oHeight + (height - oHeight) * partialTick;
     }
 
-    public int getItemColorFromMetadata(Item item, int metadata) {
-        if (item instanceof ItemBlock) {
-            Block<?> block = ((ItemBlock<?>)item).getBlock();
-            return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
-        }
-        return 0xFFFFFF;
-    }
-
     public void renderItemInFirstPerson(float partialTick)
     {
         float equipProgress = getEquippedProgress(partialTick);
@@ -68,17 +56,24 @@ public class ItemRenderer
         Lighting.enableLight();
         GL11.glPopMatrix();
         ItemStack itemstack = itemToRender;
-        GL11.glPushMatrix();
         if(itemstack != null)
         {
-            ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderItemFirstPerson(Tessellator.instance,this, player, itemstack, partialTick);
-        } else
-        {
+            float brightness = 1.0f;
+            if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
+                LightmapHelper.setLightmapCoord(mc.thePlayer.getLightmapCoord(partialTick));
+            }else {
+                brightness = mc.currentWorld.getLightBrightness(MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z));
+            }
+            ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderFirstPerson(Tessellator.instance, this,player, itemstack, brightness, 1f, partialTick);
+        } else {
+
+            GL11.glPushMatrix();
+            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         	float brightness = 1.0f;
         	if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
         		LightmapHelper.setLightmapCoord(mc.thePlayer.getLightmapCoord(partialTick));
         	}else if(mc.fullbright) {
-        		
+
         	}else {
         		brightness = mc.currentWorld.getLightBrightness(MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z));
         	}
@@ -86,26 +81,53 @@ public class ItemRenderer
             EntityRenderer<? extends Entity> render = EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
             MobRendererPlayer playerRenderer = (MobRendererPlayer)render;
             if (player.getHeldObject() == null) {
-                float f6 = 0.8F;
-                float swingProgress = player.getSwingProgress(partialTick);
-                float f14 = MathHelper.sin(swingProgress * MathHelper.PI);
-                float f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-                GL11.glTranslatef(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
-                GL11.glTranslatef(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
-                GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
-                GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-                f14 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
-                f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-                GL11.glRotatef(f18 * 70F, 0.0F, 1.0F, 0.0F);
-                GL11.glRotatef(-f14 * 20F, 0.0F, 0.0F, 1.0F);
-                mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
-                GL11.glTranslatef(-1F, 3.6F, 3.5F);
-                GL11.glRotatef(120F, 0.0F, 0.0F, 1.0F);
-                GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
-                GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
-                GL11.glScalef(1.0F, 1.0F, 1.0F);
-                GL11.glTranslatef(5.6F, 0.0F, 0.0F);
-                playerRenderer.drawFirstPersonHand(mc.thePlayer, false);
+                if (player.isLeftHanded()) {
+                    float f6 = 0.8F;
+                    float swingProgress = player.getSwingProgress(partialTick);
+                    float f14 = MathHelper.sin(swingProgress * MathHelper.PI);
+                    float f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+
+                    GL11.glScalef(-1, 1, 1);
+                    GL11.glTranslatef(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
+                    GL11.glTranslatef(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
+                    GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
+                    f14 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
+                    f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+
+                    GL11.glRotatef(f18 * 70F, 0.0F, 1.0F, 0.0F);
+                    GL11.glRotatef(-f14 * 20F, 0.0F, 0.0F, 1.0F);
+                    mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
+
+                    GL11.glTranslatef(-1F, 3.6F, 3.5F);
+                    GL11.glRotatef(120F, 0.0F, 0.0F, 1.0F);
+                    GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
+                    GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
+                    GL11.glTranslatef(5.6F, 0.0F, 0.0F);
+
+                    GL11.glPushMatrix();
+                    GL11.glScalef(-1, 1, 1);
+                    playerRenderer.drawFirstPersonHand(mc.thePlayer, true);
+                    GL11.glPopMatrix();
+                } else {
+                    float f6 = 0.8F;
+                    float swingProgress = player.getSwingProgress(partialTick);
+                    float f14 = MathHelper.sin(swingProgress * MathHelper.PI);
+                    float f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+                    GL11.glTranslatef(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
+                    GL11.glTranslatef(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
+                    GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
+                    f14 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
+                    f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+                    GL11.glRotatef(f18 * 70F, 0.0F, 1.0F, 0.0F);
+                    GL11.glRotatef(-f14 * 20F, 0.0F, 0.0F, 1.0F);
+                    mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
+                    GL11.glTranslatef(-1F, 3.6F, 3.5F);
+                    GL11.glRotatef(120F, 0.0F, 0.0F, 1.0F);
+                    GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
+                    GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
+                    GL11.glTranslatef(5.6F, 0.0F, 0.0F);
+                    playerRenderer.drawFirstPersonHand(mc.thePlayer, false);
+                }
             } else {
                 GL11.glPushMatrix();
                 float swingProgress = player.getSwingProgress(partialTick);
@@ -115,9 +137,9 @@ public class ItemRenderer
                 playerRenderer.drawHeldObject(mc.thePlayer, partialTick);
                 GL11.glPopMatrix();
             }
+            GL11.glPopMatrix();
+            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         }
-        GL11.glPopMatrix();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         Lighting.disable();
     }
 
@@ -142,7 +164,7 @@ public class ItemRenderer
             Block<?> block = Blocks.blocksList[id];
             BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(block);
 			if(mc.currentWorld.isBlockNormalCube(blockX, blockY, blockZ)) {
-				renderInsideOfBlock(partialTicks, model.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
+				renderInsideOfBlock(partialTicks, model.getOverlayTexture(meta));
 			} else {
                 id = 0;
 				for (int i = 0; i < 8; i++) {
@@ -162,7 +184,7 @@ public class ItemRenderer
 				}
                 if(Blocks.blocksList[id] != null) {
                     model = BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[id]);
-                    renderInsideOfBlock(partialTicks, model.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
+                    renderInsideOfBlock(partialTicks, model.getOverlayTexture(meta));
                 }
 			}
 
@@ -315,6 +337,5 @@ public class ItemRenderer
     private ItemStack itemToRender;
     private float height;
     private float oHeight;
-    public RenderBlocks renderBlocksInstance;
     private int lastSlot;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/Lighting.java b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
index 8afaf7acc..360bfc54d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Lighting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
@@ -20,11 +20,20 @@ public class Lighting {
 	}
 
 	public static void enableInventoryLight() {
+		// TODO this needed to change alot in the item rendering rewrite this is probably really wrong in some way
 		glPushMatrix();
-		glRotatef(-30.0f, 0.0F, 1.0F, 0.0F);
-		glRotatef(155.0f, 1.0F, 0.0F, 0.0F);
-		enableLight(0.4f, 0.5f);
+		glRotatef(90, 1, 0, 0);
+		glRotatef(105, 0, 1, 0);
+		glRotatef(90, 0, 0, 1);
+		enableLight(0.1f, 3.5f);
 		glPopMatrix();
+
+//		Original
+//		glPushMatrix();
+//		glRotatef(-30.0f, 0.0F, 1.0F, 0.0F);
+//		glRotatef(155.0f, 1.0F, 0.0F, 0.0F);
+//		enableLight(0.4f, 0.5f);
+//		glPopMatrix();
 	}
 
 	public static void enableLight() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
similarity index 98%
rename from game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java
rename to game/client/src/main/java/net/minecraft/client/render/LightingCache.java
index 188f03851..77050245e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
@@ -7,7 +7,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.WorldSource;
 
-final public class RenderBlockCache {
+final public class LightingCache {
     private final Minecraft mc = Minecraft.getMinecraft();
     
     private static final int CACHE_RANGE = 1;
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
index a41faa6bf..26f24c9fd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -345,6 +345,10 @@ public class LightmapHelper {
 	public static int getLightmapCoord(int skylight, int blocklight) {
 		return skylight << 20 | blocklight << 4;
 	}
+
+	public static int getLightmapCoord(float skylight, float blocklight) {
+		return getLightmapCoord((int) (0xF * skylight), (int) (0xF * blocklight));
+	}
 	
 	public static int getOverbrightLightmapCoord(int skylight) {
 		return getLightmapCoord(skylight, 15);
@@ -394,9 +398,17 @@ public class LightmapHelper {
 	public static int setBlocklightValue(int lightmapCoord, int blocklight) {
 		return lightmapCoord & 0xFFFF0000 | blocklight << 4;
 	}
+
+	public static int getBlockLightFromCoord(int lightmapCoord) {
+		return  ((lightmapCoord) & 0xFFFF) >> 4;
+	}
 	
 	public static int setSkylightValue(int lightmapCoord, int skylight) {
 		return lightmapCoord & 0x0000FFFF | skylight << 20;
 	}
 
+	public static int getSkyLightFromCoord(int lightmapCoord) {
+		return  (lightmapCoord & 0xFFFF0000) >> 20;
+	}
+
 }
